// 20rkmnDlg.cpp : implementation file
//

// 20

#include "stdafx.h"
#include "20rkmn.h"
#include "20rkmnDlg.h"

#include "DlgVyberOsobu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy20rkmnDlg dialog

CMy20rkmnDlg::CMy20rkmnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy20rkmnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy20rkmnDlg)
	m_strJmeno = _T("");
	m_strPrijmeni = _T("");
	m_nPohlavi = -1;
	m_nRokNar = 0;
	m_nRokUmr = 0;
	m_strID = _T("");
	m_strMatka = _T("");
	m_strOtec = _T("");
	m_nLook = 0;
	m_nOrder = 1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nPoradi = 0;
}

void CMy20rkmnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy20rkmnDlg)
	DDX_Control(pDX, IDC_TREE, m_Tree);
	DDX_Text(pDX, IDC_JMENO, m_strJmeno);
	DDX_Text(pDX, IDC_PRIJMENI, m_strPrijmeni);
	DDX_CBIndex(pDX, IDC_POHLAVI, m_nPohlavi);
	DDX_Text(pDX, IDC_RNAR, m_nRokNar);
	DDX_Text(pDX, IDC_RUMR, m_nRokUmr);
	DDX_Text(pDX, IDC_ID, m_strID);
	DDX_Text(pDX, IDC_MATKA, m_strMatka);
	DDX_Text(pDX, IDC_OTEC, m_strOtec);
	DDX_CBIndex(pDX, IDC_LOOK, m_nLook);
	DDX_Text(pDX, IDC_ORDER, m_nOrder);
	DDV_MinMaxInt(pDX, m_nOrder, 1, 9999);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy20rkmnDlg, CDialog)
	//{{AFX_MSG_MAP(CMy20rkmnDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_NOTIFY(NM_CLICK, IDC_TREE, OnClickTree)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, OnSelchangedTree)
	ON_BN_CLICKED(IDC_SELMATKA, OnSelmatka)
	ON_BN_CLICKED(IDC_SELOTEC, OnSelotec)
	ON_BN_CLICKED(IDC_UPDATE, OnUpdate)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_FINDOUT, OnFindout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy20rkmnDlg message handlers

BOOL CMy20rkmnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy20rkmnDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy20rkmnDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMy20rkmnDlg::OnAdd() 
{
	CString strID;
	strID.Format("I%d", m_rodokmen.GetPocetOsob());

	m_osCurrent.Reset();
	m_osCurrent.SetID(m_rodokmen.GetFirstFreeID());
	UpdateOsoba();
}

void CMy20rkmnDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CMy20rkmnDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CMy20rkmnDlg::OnLoad() 
{
	CFileDialog fd(TRUE, "*.xml", NULL, 0, "XML Dokumenty|*.xml||");

	if (fd.DoModal() == IDCANCEL)
		return;

	CString fn = fd.GetPathName();

	if (!m_rodokmen.LoadFromFile(fn))
	{
		AfxMessageBox("Soubor nebyl naten", MB_ICONERROR);
		return;
	}

	FillTreeList();
}

void CMy20rkmnDlg::FillTreeList()
{
	m_rodokmen.FillTreeList(m_Tree);
}

void CMy20rkmnDlg::OnClickTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
}

void CMy20rkmnDlg::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NMTREEVIEW* pNMTreeView = (NMTREEVIEW*)pNMHDR;

	vOsoba* os;
	if ((os = m_rodokmen.GetOsobaByTreeItem(pNMTreeView->itemNew.hItem)) == NULL)
		return;

	// Nastavit jako aktualne editovanou osubku
	m_osCurrent = *os;
	UpdateOsoba();
	
	*pResult = 0;
}

void CMy20rkmnDlg::UpdateOsoba()
{
	m_strJmeno = m_osCurrent.GetJmeno();
	m_strPrijmeni= m_osCurrent.GetPrijmeni();
	m_nRokNar = m_osCurrent.GetRokNar();
	m_nRokUmr = m_osCurrent.GetRokUmrti();
	m_nPohlavi = m_osCurrent.GetPohlavi();
	m_strID = m_osCurrent.GetID();
	m_strMatka = m_rodokmen.GetOsobaByID(m_osCurrent.GetMatka()) ? m_rodokmen.GetOsobaByID(m_osCurrent.GetMatka())->GetFullName() : "(nen)";
	m_strOtec = m_rodokmen.GetOsobaByID(m_osCurrent.GetOtec()) ? m_rodokmen.GetOsobaByID(m_osCurrent.GetOtec())->GetFullName() : "(nen)";

	UpdateData(FALSE);
}

void CMy20rkmnDlg::OnSelmatka() 
{
	CDlgVyberOsobu vo;
	vo.m_rodokmen = m_rodokmen;
	vo.m_bMuzi = false;
	vo.m_originID = m_osCurrent.GetID();

	if (vo.DoModal() == IDCANCEL)
	{
		FillTreeList();
		return;
	}
	
	m_osCurrent.SetMatka(vo.m_osVystup.GetID());

//	m_rodokmen.ReplaceOsoba(&m_osCurrent);
//	FillTreeList();
	UpdateOsoba();
}

void CMy20rkmnDlg::OnSelotec() 
{
	CDlgVyberOsobu vo;
	vo.m_rodokmen = m_rodokmen;
	vo.m_bZeny = false;
	vo.m_originID = m_osCurrent.GetID();

	if (vo.DoModal() == IDCANCEL)
	{
		FillTreeList();
		return;
	}
	
	m_osCurrent.SetOtec(vo.m_osVystup.GetID());

//	m_rodokmen.ReplaceOsoba(&m_osCurrent);
//	FillTreeList();
	UpdateOsoba();
}

void CMy20rkmnDlg::OnUpdate() 
{
	UpdateData();

	if (m_nRokNar > m_nRokUmr && m_nRokUmr != 0)
	{
		AfxMessageBox("Neplatn rok narozen/mrt");
		return;
	}

	m_osCurrent.SetJmeno(m_strJmeno);
	m_osCurrent.SetPrijmeni(m_strPrijmeni);
	m_osCurrent.SetRokNar(m_nRokNar);
	m_osCurrent.SetRokUmrti(m_nRokUmr);
	m_osCurrent.SetPohlavi(m_nPohlavi);
	m_osCurrent.SetID(m_strID);
	m_osCurrent.SetMatka(m_rodokmen.GetOsobaByID(m_osCurrent.GetMatka()) ? m_rodokmen.GetOsobaByID(m_osCurrent.GetMatka())->GetID() : "");
	m_osCurrent.SetOtec(m_rodokmen.GetOsobaByID(m_osCurrent.GetOtec()) ? m_rodokmen.GetOsobaByID(m_osCurrent.GetOtec())->GetID() : "");
	
	if (*m_osCurrent.GetID() == 0)
	{
		AfxMessageBox("Nejprve vygenerujte nov ID osoby nebo pouijte stvajc pro opravu osoby");
		return;
	}

	// aktualizuje editovanou poloku v rodokmenu
	m_rodokmen.RemoveOsoba(&m_osCurrent);
	m_rodokmen.AddOsoba(&m_osCurrent);

	FillTreeList();
}

void CMy20rkmnDlg::OnRemove() 
{
	if (m_rodokmen.MaPotomky(&m_osCurrent))
	{
		AfxMessageBox("Vybran osoba m potomky, nelze ji tedy odstranit (nejprve odstrane jej potomky)");
		return;
	}

	m_rodokmen.RemoveOsoba(&m_osCurrent);
	FillTreeList();
}

void CMy20rkmnDlg::OnSave() 
{
	CFileDialog fd(FALSE, "*.xml", NULL, 0, "XML Dokumenty|*.xml||");

	if (fd.DoModal() == IDCANCEL)
		return;

	CString fn = fd.GetPathName();

	if (!m_rodokmen.SaveToFile(fn))
	{
		AfxMessageBox("Soubor se nepodailo uloit", MB_ICONERROR);
		return;
	}

	AfxMessageBox("Soubor uloen", MB_ICONINFORMATION);
}

void CMy20rkmnDlg::OnFindout() 
{
	UpdateData();
	
	vOsoba* fnd = NULL;
	bool bJsouDalsi = false;

	switch (m_nLook)
	{
	case 0: // Najt manele/manelku
		fnd = m_rodokmen.NajdiPartnera(&m_osCurrent);
		break;

	case 1: // najit deti
		fnd = m_rodokmen.NajdiDite(&m_osCurrent, m_nOrder-1);//, &bJsouDalsi);
		break;

	case 2: // najit rodice
		fnd = m_rodokmen.NajdiOtce(&m_osCurrent);
		break;

	case 3: // najit prarodice
		fnd = m_rodokmen.NajdiDedecka(&m_osCurrent);
		break;

	case 4: // najit vnouce
		fnd = m_rodokmen.NajdiVnouce(&m_osCurrent);
		break;

	default:
		break;
	}

	if (fnd == NULL)
	{
		AfxMessageBox("Hledn bylo nespn");
		m_nPoradi = 0;
	}
	else
	{
		m_Tree.SelectItem(fnd->m_hItem);

		if (!bJsouDalsi)
			m_nPoradi = 0;

		else m_nPoradi++;
	}
}
